import 'rxjs/add/operator/distinctUntilChanged';
import { Observable } from 'rxjs/Observable';
import { ReduxStateInterface } from '@harmowatch/redux-decorators';
import { ReduxStateDefinition } from '../interfaces/redux-state-definition.interface';
import { ReduxActionWithPayload } from '../interfaces/redux-action.interface';
export declare abstract class ReduxStateProvider<S> implements ReduxStateInterface<S> {
    static instancesByName: {
        [stateName: string]: ReduxStateProvider<{}>;
    };
    readonly name: string;
    readonly stateDef: ReduxStateDefinition;
    protected selectorCache: {
        [selector: string]: Observable<{}>;
    };
    protected reducerMethodsByType: {
        [actionType: string]: Function[];
    };
    constructor(stateDefs?: ReduxStateDefinition[]);
    getInitialState(): S | Promise<S> | Observable<S>;
    select<T>(selector?: string): Observable<T>;
    getState(): Promise<S>;
    reduce<P>(state: S, action: ReduxActionWithPayload<P>): any;
    private getReducerMethods(reducerClassInstance);
}
